/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton interface for Bison GLR parsers in C

   Copyright (C) 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TK_TAG = 258,
     TK_IDENT = 259,
     TK_CONST = 260,
     TK_DOTDOTDOT = 261,
     TK_LAMBDA = 262,
     TK_FROM = 263,
     TK_TO = 264,
     TK_SUCHTHAT = 265,
     TK_UMINUS = 266,
     TK_UPLUS = 267,
     TK_POW = 268,
     TK_LESS = 269,
     TK_LESSEQ = 270,
     TK_MORE = 271,
     TK_MOREEQ = 272,
     TK_NOTEQ = 273,
     TK_LAND = 274,
     TK_LOR = 275,
     TK_BAND = 276,
     TK_BOR = 277,
     TK_JOIN = 278,
     TK_IF = 279,
     TK_THEN = 280,
     TK_ELSE = 281,
     TK_CHAR = 282,
     TK_SHORT = 283,
     TK_CLASS = 284,
     TK_SCOPE = 285,
     TK_INT = 286,
     TK_FLOAT = 287,
     TK_DOUBLE = 288,
     TK_SIGNED = 289,
     TK_UNSIGNED = 290,
     TK_COMPLEX = 291,
     TK_SEPARATOR = 292,
     TK_DIALOG = 293,
     TK_LSHIFT = 294,
     TK_RSHIFT = 295,
     TK_PNOTEQ = 296,
     TK_PEQ = 297,
     TK_EQ = 298,
     TK_APPLICATION = 299
   };
#endif


/* Copy the first part of user declarations.  */
#line 1 "parse.y"


/* Parse ip's macro language.
 */

/*

    Copyright (C) 1991-2003 The National Gallery

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

/*

    These files are distributed with VIPS - http://www.vips.ecs.soton.ac.uk

 */

#include "ip.h"

/*
#define DEBUG
 */

/* trace text read system
#define DEBUG_CHARACTER
 */

/* The lexer from lex.l.
 */
int yylex( void );
void yyrestart( FILE *input_file );

/* Declare file-private stuff, shared with the lexer. Bison will put this
 * stuff into parse.h, so just declare, don't define. Sadly we can't have
 * these things static :(
 */

/* Global .. the symbol whose definition we are currently parsing, the symbol
 * which all defs in this parse action should be made local to.
 */
extern Symbol *current_symbol;
extern Symbol *root_symbol;

/* The current parse context.
 */
extern Compile *current_compile;
extern ParseNode *current_parsenode;

/* The kit we are adding new symbols to.
 */
extern Toolkit *current_kit;

/* Where it should go in the kit.
 */
extern int tool_position;

/* Lineno of start of last top-level def.
 */
extern int last_top_lineno;

/* Text we've gathered in this lex.
 */
extern char lex_text_buffer[MAX_STRSIZE];

/* Stack of symbols for parser - each represents a new scope level.
 */
extern Symbol *scope_stack_symbol[MAX_SSTACK];
extern Compile *scope_stack_compile[MAX_SSTACK];
extern int scope_sp;

/* Use to generate unique ids for anonymouse parse objects (eg. lambdas etc).
 */
extern int parse_object_id;

/* Get text for parsed objects.
 */
char *input_text( char *out );
void input_reset( void );
void input_push( int n );
void input_backtoch( char ch );
void input_back1( void );
void input_pop( void );

/* Nest and unnest scopes.
 */
void scope_push( void );
void scope_pop( void );
void scope_pop_all( void );
void scope_reset( void );

/* Helper functions.
 */
void *parse_toplevel_end( Symbol *sym );
void *parse_access_end( Symbol *sym, Symbol *main );



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE 
#line 112 "parse.y"
{
	struct sym_table *yy_symtab;
	ParseNode *yy_node;
	char *yy_name;
	ParseConst yy_const;
	UnOp yy_uop;
	BinOp yy_binop;
}
/* Line 2604 of glr.c.  */
#line 213 "parse.h"
	YYSTYPE;
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{

  char yydummy;

} YYLTYPE;
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;



